
/* 
 * @Program to query XML with an XPath expression. 
 * XmlQuerywithXpath.java 
 * Author:-RoseIndia Team
 * Date:-17-July-2008
 */
import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.xpath.*;

public class XmlQuerywithXpath {

    public static void main(String[] args) throws Exception {
        
        DocumentBuilderFactory Factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = Factory.newDocumentBuilder();
        Document doc = builder.parse("Document4.xml");

        //creating an XPathFactory:
        XPathFactory factory = XPathFactory.newInstance();
        //using this factory to create an XPath object: 
        XPath xpath = factory.newXPath();
        //XPath object created compiles the XPath expression: 
        XPathExpression expr = xpath.compile("//Employee[City='Haldwani']/name/text()");

        //expression is evaluated with respect to a certain context node which is doc.
        Object result = expr.evaluate(doc, XPathConstants.NODESET);
        NodeList nodeList = (NodeList) result;
        for (int i = 0; i < nodeList.getLength(); i++) {
        System.out.println("Name of the Employee Belonging to City Haldwani is:" + nodeList.item(i).getNodeValue());
        }
    }
}
